             .title        "Jaleco (INES 72) Plugin"

;11/28/07
;BootGod

;12/07/09
;BootGod
;wr_bank adjusted, should work for any ines 72 cart now

             ;vectors for standard system calls

send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

address:       .equ 00e0h
address_lo:    .equ 00e0h
address_hi:    .equ 00e1h
curbank:    .equ 00e2h
banksleft:    .equ 00e3h

reg:       .equ 00e8h
reg_lo:    .equ 00e8h
reg_hi:    .equ 00e9h


temp_crc:    .equ 00ech

;plugin header defines
p_ver: = 2	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Jaleco JF-17/26/28 carts"
             .db " (JF-28 untested!)"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 128 >> 4,0 >> 4
             .db 128 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here
             
;determine H or V mirroring

             ldx #00h
             
             lda #020h
             jsr wr_ppu
             lda #055h
             sta 2007h
             lda #0aah
             sta 2007h
             lda #024h
             jsr wr_ppu
             lda 2007h
             lda 2007h
             cmp #055h
             bne horz_mir
             lda 2007h
             cmp #0aah
             bne horz_mir
             lda #020h
             jsr wr_ppu
             lda #0aah
             sta 2007h
             lda #024h
             jsr wr_ppu
             lda 2007h
             lda 2007h
             cmp #0aah
             bne horz_mir
             inx

horz_mir:    txa
             jsr send_byte   ;send byte

;send PRG size info (128K)

got_prg:     lda #0
             sta curbank
             jsr send_byte	;send num pages lo-byte
             lda #2
             jsr send_byte	;send num pages hi-byte
             lda #001h
             jsr send_byte	;send type PRG

             lda #8
             sta banksleft

next_prg:    lda curbank
             ora #080h		;bit 7 controls PRG select
             jsr wr_bank	;write cur bank num
             lda curbank
             jsr wr_bank	;write again with upper bits clear
             inc curbank

             lda #0
             sta address_lo
             lda #080h
             sta address_hi	;set address to $8000

             ldy #0
             ldx #64		;setup for 16K bank dump

dump_prg:    lda (address),y
             jsr send_byte
             iny
             bne dump_prg
             inc address_hi
             dex
             bne dump_prg
             dec banksleft
             bne next_prg
             
;send CHR size info (128K)
             
got_chr:     lda #0
             sta curbank
             sta address_lo
             sta address_hi	;set address to CHR $0000
             jsr send_byte
             lda #2		;200h pages
             jsr send_byte
             lda #02h
             jsr send_byte	;send our header

             lda #16
             sta banksleft

send_bank:   lda curbank
             ora #040h		;bit 6 controls CHR select
             jsr wr_bank	;set bank
             lda curbank
             jsr wr_bank	;write again with upper bits clear
             inc curbank
             lda #0
             jsr wr_ppu
             lda 2007h

             ldx #32		;setup for 8K bank dump
             ldy #0

send_blk:    lda 2007h
             jsr send_byte
             iny
             bne send_blk
             dex
             bne send_blk
             dec banksleft
             bne send_bank

             
             lda #000h
             jsr send_byte
             lda #000h
             jsr send_byte
             lda #000h
             jsr send_byte  ;send end block
             rts


wr_bank:     sta reg		;store desired bank
             lda #0
             sta address_lo
             lda #0c0h
             sta address_hi 	;start search at $c000
             ldx #64
             ldy #0

wrb_loop:    lda (address),y
             cmp reg		;check current byte
             beq gotit
             iny
             bne wrb_loop
             inc address_hi
             bne wrb_loop
             
gotit:       lda (address),y             
             sta (address),y	;do the write
             
             rts



             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

             .end
